diff --git a/arch/ppc/config.in b/arch/ppc/config.in
index 08c6c40..133e8d8 100644
--- a/arch/ppc/config.in
+++ b/arch/ppc/config.in
@@ -892,6 +892,11 @@ else
   fi
 fi
 
+bool 'Interrupt pipeline' CONFIG_IPIPE
+if [ "$CONFIG_IPIPE" = "y" ]; then
+  bool 'Check for illicit cross-domain calls' CONFIG_IPIPE_DEBUG_CONTEXT
+fi
+
 bool 'Networking support' CONFIG_NET
 bool 'Sysctl support' CONFIG_SYSCTL
 bool 'System V IPC' CONFIG_SYSVIPC
diff --git a/arch/ppc/kernel/Makefile b/arch/ppc/kernel/Makefile
index 96b1cde..4843b45 100644
--- a/arch/ppc/kernel/Makefile
+++ b/arch/ppc/kernel/Makefile
@@ -46,12 +46,14 @@ export-objs			:= ppc_ksyms.o time.o ocp.o ppc4xx_setup.o \
 					ppc4xx_dma.o ppc4xx_sgdma.o \
 					ppc4xx_stbdma.o ppc4xx_pm.o \
 					gt64260_common.o mpc5xxx_common.o \
-					ppc85xx_common.o ppc83xx_common.o
+					ppc85xx_common.o ppc83xx_common.o \
+					ipipe.o
 
 obj-y				:= entry.o traps.o irq.o idle.o time.o misc.o \
 					process.o signal.o ptrace.o align.o \
 					semaphore.o syscalls.o setup.o \
 					cputable.o ppc_htab.o
+obj-$(CONFIG_IPIPE)		+= ipipe.o
 ifneq ($(CONFIG_6xx),y)
 obj-y				+= idle_gen.o
 endif
diff --git a/arch/ppc/kernel/entry.S b/arch/ppc/kernel/entry.S
index d19d49d..cdb86ff 100644
--- a/arch/ppc/kernel/entry.S
+++ b/arch/ppc/kernel/entry.S
@@ -53,6 +53,21 @@ _GLOBAL(DoSyscall)
 	lis	r10,0x1000
 	andc	r11,r11,r10
 	stw	r11,_CCR(r1)
+#ifdef CONFIG_IPIPE
+	addi	r3,r1,GPR0
+	bl	__ipipe_syscall_root
+	cmpwi	r3,0
+	lwz	r3,GPR3(r1)
+	lwz	r0,GPR0(r1)
+	lwz	r4,GPR4(r1)
+	lwz	r5,GPR5(r1)
+	lwz	r6,GPR6(r1)
+	lwz	r7,GPR7(r1)
+	lwz	r8,GPR8(r1)
+	lwz	r9,GPR9(r1)
+	bgt	restore
+	blt	ret_from_syscall_1
+#endif /* CONFIG_IPIPE */
 #ifdef SHOW_SYSCALLS
 #ifdef SHOW_SYSCALLS_TASK
 	lis	r31,show_syscalls_task@ha
@@ -280,7 +295,11 @@ ret_from_fork:
 	lwz	r0,TASK_PTRACE(r2)
 	andi.	r0,r0,PT_TRACESYS
 	bnel-	syscall_trace
+#ifdef CONFIG_IPIPE
+	b	ret_from_except_1
+#else	
 	b	ret_from_except
+#endif
 
 	.globl	ret_from_intercept
 ret_from_intercept:
@@ -288,10 +307,21 @@ ret_from_intercept:
 	 * We may be returning from RTL and cannot do the normal checks
 	 * -- Cort
 	 */
+	/*
+	 * We may also be returning from Adeos and cannot do the normal checks either
+	 * -- rpm
+	 */
 	cmpi	0,r3,0
 	beq	restore
+	b	ret_from_except_1
 	.globl	ret_from_except
 ret_from_except:
+#ifdef CONFIG_IPIPE
+        bl	__ipipe_check_root
+        cmpwi	r3, 0
+        beq-	restore
+#endif /* CONFIG_IPIPE */
+ret_from_except_1:
 	lwz	r3,_MSR(r1)	/* Returning to user mode? */
 	andi.	r3,r3,MSR_PR
 	beq+	do_signal_ret	/* if so, check need_resched and signals */
diff --git a/arch/ppc/kernel/head.S b/arch/ppc/kernel/head.S
index 7b9e0c2..2605305 100644
--- a/arch/ppc/kernel/head.S
+++ b/arch/ppc/kernel/head.S
@@ -435,7 +435,11 @@ HardwareInterrupt:
 	bl	transfer_to_handler
 	.globl do_IRQ_intercept
 do_IRQ_intercept:
-	.long	do_IRQ;
+#ifdef CONFIG_IPIPE
+	.long	__ipipe_grab_irq
+#else /* !CONFIG_IPIPE */
+	.long	do_IRQ
+#endif /* CONFIG_IPIPE */
 	.long	ret_from_intercept
 
 /* Alignment exception */
@@ -485,7 +489,11 @@ Decrementer:
 	bl	transfer_to_handler
 	.globl timer_interrupt_intercept
 timer_interrupt_intercept:
+#ifdef CONFIG_IPIPE
+	.long	__ipipe_grab_timer
+#else /* !CONFIG_IPIPE */
 	.long	timer_interrupt
+#endif /* CONFIG_IPIPE */
 	.long	ret_from_intercept
 
 	STD_EXCEPTION(0xa00, Trap_0a, UnknownException)
diff --git a/arch/ppc/kernel/head_440.S b/arch/ppc/kernel/head_440.S
index a52bf16..d8cbb41 100644
--- a/arch/ppc/kernel/head_440.S
+++ b/arch/ppc/kernel/head_440.S
@@ -539,7 +539,11 @@ interrupt_base:
 	li      r4,0
 	bl      transfer_to_handler
 _GLOBAL(do_IRQ_intercept)
-	.long   do_IRQ
+#ifdef CONFIG_IPIPE
+	.long	__ipipe_grab_irq
+#else /* !CONFIG_IPIPE */
+	.long	do_IRQ
+#endif /* CONFIG_IPIPE */
 	.long   ret_from_intercept
 	.long	0x500
 
@@ -590,7 +594,11 @@ _GLOBAL(do_IRQ_intercept)
 	li      r20,MSR_KERNEL
 	bl      transfer_to_handler
 _GLOBAL(timer_interrupt_intercept)
-	.long   timer_interrupt
+#ifdef CONFIG_IPIPE
+	.long	__ipipe_grab_timer
+#else /* !CONFIG_IPIPE */
+	.long	timer_interrupt
+#endif /* CONFIG_IPIPE */
 	.long   ret_from_intercept
 	.long	0x1000
 
diff --git a/arch/ppc/kernel/head_44x.S b/arch/ppc/kernel/head_44x.S
index bc7f216..7f53079 100644
--- a/arch/ppc/kernel/head_44x.S
+++ b/arch/ppc/kernel/head_44x.S
@@ -552,7 +552,11 @@ interrupt_base:
 	li      r4,0
 	bl      transfer_to_handler
 _GLOBAL(do_IRQ_intercept)
-	.long   do_IRQ
+#ifdef CONFIG_IPIPE
+	.long	__ipipe_grab_irq
+#else /* !CONFIG_IPIPE */
+	.long	do_IRQ
+#endif /* CONFIG_IPIPE */
 	.long   ret_from_intercept
 	.long	0x500
 
@@ -603,7 +607,11 @@ _GLOBAL(do_IRQ_intercept)
 	li      r20,MSR_KERNEL
 	bl      transfer_to_handler
 _GLOBAL(timer_interrupt_intercept)
-	.long   timer_interrupt
+#ifdef CONFIG_IPIPE
+	.long	__ipipe_grab_timer
+#else /* !CONFIG_IPIPE */
+	.long	timer_interrupt
+#endif /* CONFIG_IPIPE */
 	.long   ret_from_intercept
 	.long	0x1000
 
diff --git a/arch/ppc/kernel/head_4xx.S b/arch/ppc/kernel/head_4xx.S
index 2f5d73f..fda2742 100644
--- a/arch/ppc/kernel/head_4xx.S
+++ b/arch/ppc/kernel/head_4xx.S
@@ -384,7 +384,11 @@ label:
 	li	r4,0
 	bl	transfer_to_handler
 _GLOBAL(do_IRQ_intercept)
+#ifdef CONFIG_IPIPE
+	.long	__ipipe_grab_irq
+#else /* !CONFIG_IPIPE */
 	.long	do_IRQ
+#endif /* CONFIG_IPIPE */
 	.long	ret_from_intercept
 
 /* 0x0600 - Alignment Exception
@@ -456,7 +460,11 @@ _GLOBAL(do_IRQ_intercept)
 	li	r20,MSR_KERNEL
 	bl	transfer_to_handler
 _GLOBAL(timer_interrupt_intercept)
+#ifdef CONFIG_IPIPE
+	.long	__ipipe_grab_timer
+#else /* !CONFIG_IPIPE */
 	.long	timer_interrupt
+#endif /* CONFIG_IPIPE */
 	.long	ret_from_intercept
 
 #if 0
diff --git a/arch/ppc/kernel/head_8xx.S b/arch/ppc/kernel/head_8xx.S
index d610508..b9de7ff 100644
--- a/arch/ppc/kernel/head_8xx.S
+++ b/arch/ppc/kernel/head_8xx.S
@@ -231,7 +231,11 @@ HardwareInterrupt:
 	bl	transfer_to_handler
 	.globl	do_IRQ_intercept
 do_IRQ_intercept:
-	.long	do_IRQ;
+#ifdef CONFIG_IPIPE
+	.long   __ipipe_grab_irq
+#else /* !CONFIG_IPIPE */
+	.long	do_IRQ
+#endif /* CONFIG_IPIPE */
 	.long	ret_from_intercept
 
 /* Alignment exception */
@@ -268,7 +272,11 @@ Decrementer:
 	bl	transfer_to_handler
 	.globl	timer_interrupt_intercept
 timer_interrupt_intercept:
-	.long	timer_interrupt
+#ifdef CONFIG_IPIPE
+	.long   __ipipe_grab_timer
+#else /* !CONFIG_IPIPE */
+	.long   timer_interrupt
+#endif /* CONFIG_IPIPE */
 	.long	ret_from_intercept
 
 	STD_EXCEPTION(0xa00, Trap_0a, UnknownException)
diff --git a/arch/ppc/kernel/head_e500.S b/arch/ppc/kernel/head_e500.S
index 9d9fc68..f3149c4 100644
--- a/arch/ppc/kernel/head_e500.S
+++ b/arch/ppc/kernel/head_e500.S
@@ -618,7 +618,11 @@ interrupt_base:
 	li      r4,0
 	bl      transfer_to_handler
 _GLOBAL(do_IRQ_intercept)
-	.long   do_IRQ
+#ifdef CONFIG_IPIPE
+	.long	__ipipe_grab_irq
+#else /* !CONFIG_IPIPE */
+	.long	do_IRQ
+#endif /* CONFIG_IPIPE */
 	.long   ret_from_intercept
 	.long	0x500
 
@@ -669,7 +673,11 @@ _GLOBAL(do_IRQ_intercept)
 	li      r20,MSR_KERNEL
 	bl      transfer_to_handler
 _GLOBAL(timer_interrupt_intercept)
-	.long   timer_interrupt
+#ifdef CONFIG_IPIPE
+	.long	__ipipe_grab_timer
+#else /* !CONFIG_IPIPE */
+	.long	timer_interrupt
+#endif /* CONFIG_IPIPE */
 	.long   ret_from_intercept
 	.long	0x900
 
diff --git a/arch/ppc/kernel/idle.c b/arch/ppc/kernel/idle.c
index 29a95bf..ea58c00 100644
--- a/arch/ppc/kernel/idle.c
+++ b/arch/ppc/kernel/idle.c
@@ -50,6 +50,7 @@ int idled(void)
 	current->counter = -100;
 	init_idle();
 	for (;;) {
+		ipipe_suspend_domain();
 #ifdef CONFIG_SMP
 		if (!do_power_save) {
 			/*
diff --git a/arch/ppc/kernel/ipic.c b/arch/ppc/kernel/ipic.c
index 2ee19ac..5d85ee6 100644
--- a/arch/ppc/kernel/ipic.c
+++ b/arch/ppc/kernel/ipic.c
@@ -377,7 +377,7 @@ static inline struct ipic * ipic_from_irq(unsigned int irq)
 	return primary_ipic;
 }
 
-static void ipic_enable_irq(unsigned int irq)
+static void __ipic_enable_irq(unsigned int irq)
 {
 	struct ipic *ipic = ipic_from_irq(irq);
 	unsigned int src = irq - ipic->irq_offset;
@@ -388,7 +388,17 @@ static void ipic_enable_irq(unsigned int irq)
 	ipic_write(ipic->regs, ipic_info[src].mask, temp);
 }
 
-static void ipic_disable_irq(unsigned int irq)
+static void ipic_enable_irq(unsigned int irq)
+{
+	unsigned long flags;
+
+	local_irq_save_hw_cond(flags);
+	__ipic_enable_irq(irq);
+	ipipe_irq_unlock(irq);
+	local_irq_restore_hw_cond(flags);
+}
+
+static void __ipic_disable_irq(unsigned int irq)
 {
 	struct ipic *ipic = ipic_from_irq(irq);
 	unsigned int src = irq - ipic->irq_offset;
@@ -399,23 +409,39 @@ static void ipic_disable_irq(unsigned int irq)
 	ipic_write(ipic->regs, ipic_info[src].mask, temp);
 }
 
+static void ipic_disable_irq(unsigned int irq)
+{
+	unsigned long flags;
+
+	local_irq_save_hw_cond(flags);
+	__ipic_disable_irq(irq);
+	ipipe_irq_lock(irq);
+	local_irq_restore_hw_cond(flags);
+}
+
 static void ipic_disable_irq_and_ack(unsigned int irq)
 {
 	struct ipic *ipic = ipic_from_irq(irq);
 	unsigned int src = irq - ipic->irq_offset;
+	unsigned long flags;
 	u32 temp;
 
-	ipic_disable_irq(irq);
+	local_irq_save_hw_cond(flags);
+
+	__ipic_disable_irq(irq);
 
 	temp = ipic_read(ipic->regs, ipic_info[src].pend);
 	temp |= (1 << (31 - ipic_info[src].bit));
 	ipic_write(ipic->regs, ipic_info[src].pend, temp);
+
+	local_irq_restore_hw_cond(flags);
 }
 
 static void ipic_end_irq(unsigned int irq)
 {
-	if (!(irq_desc[irq].status & (IRQ_DISABLED|IRQ_INPROGRESS)))
-		ipic_enable_irq(irq);
+	if (!ipipe_root_domain_p ||
+	    !(irq_desc[irq].status & (IRQ_DISABLED|IRQ_INPROGRESS)))
+		__ipic_enable_irq(irq);
 }
 
 struct hw_interrupt_type ipic = {
diff --git a/arch/ppc/kernel/ipipe.c b/arch/ppc/kernel/ipipe.c
new file mode 100644
index 0000000..9319405
--- /dev/null
+++ b/arch/ppc/kernel/ipipe.c
@@ -0,0 +1,406 @@
+/* -*- linux-c -*-
+ * linux/arch/ppc/kernel/ipipe.c
+ *
+ * Copyright (C) 2009 Philippe Gerum (I-pipe backport from 2.6 series)
+ * Copyright (C) 2005 Heikki Lindholm (PPC64 port).
+ * Copyright (C) 2004 Wolfgang Grandegger (Adeos/ppc port over 2.4).
+ * Copyright (C) 2002-2007 Philippe Gerum.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, Inc., 675 Mass Ave, Cambridge MA 02139,
+ * USA; either version 2 of the License, or (at your option) any later
+ * version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ *
+ * Architecture-dependent I-PIPE core support for PowerPC 32/64bit.
+ */
+
+#include <linux/kernel.h>
+#include <linux/smp.h>
+#include <linux/sched.h>
+#include <linux/slab.h>
+#include <linux/bitops.h>
+#include <linux/interrupt.h>
+#include <linux/irq.h>
+#include <linux/module.h>
+#include <linux/kernel_stat.h>
+#include <asm/system.h>
+#include <asm/mmu_context.h>
+#include <asm/unistd.h>
+#include <asm/machdep.h>
+#include <asm/atomic.h>
+#include <asm/hardirq.h>
+#include <asm/io.h>
+#include <asm/time.h>
+
+static void __ipipe_do_IRQ(unsigned irq, void *cookie);
+
+static void __ipipe_do_timer(unsigned irq, void *cookie);
+
+DEFINE_PER_CPU(struct pt_regs, __ipipe_tick_regs);
+
+#define DECREMENTER_MAX	0x7fffffff
+
+/*
+ * ipipe_critical_enter() -- Grab the superlock excluding all CPUs
+ * but the current one from a critical section. This lock is used when
+ * we must enforce a global critical section for a single CPU in a
+ * possibly SMP system whichever context the CPUs are running.
+ */
+unsigned long ipipe_critical_enter(void (*syncfn) (void))
+{
+	unsigned long flags;
+
+	local_irq_save_hw(flags);
+
+	return flags;
+}
+
+/* ipipe_critical_exit() -- Release the superlock. */
+
+void ipipe_critical_exit(unsigned long flags)
+{
+	local_irq_restore_hw(flags);
+}
+
+void __ipipe_init_platform(void)
+{
+	unsigned int virq;
+
+	/*
+	 * Allocate a virtual IRQ for the decrementer trap early to
+	 * get it mapped to IPIPE_VIRQ_BASE
+	 */
+
+	virq = ipipe_alloc_virq();
+
+	if (virq != IPIPE_TIMER_VIRQ)
+		panic("I-pipe: cannot reserve timer virq #%d (got #%d)",
+		      IPIPE_TIMER_VIRQ, virq);
+}
+
+void __ipipe_end_irq(unsigned irq)
+{
+	irq_desc_t *desc = get_irq_desc(irq);
+	if (desc->handler) {
+		if (desc->handler->end)
+			desc->handler->end(irq);
+		else if (desc->handler->enable)
+			desc->handler->enable(irq);
+	}
+}
+
+void __ipipe_enable_irqdesc(struct ipipe_domain *ipd, unsigned irq)
+{
+	get_irq_desc(irq)->status &= ~IRQ_DISABLED;
+}
+
+static void __ipipe_ack_irq(unsigned irq, struct irq_desc *desc)
+{
+	ack_irq(irq);
+}
+
+/*
+ * __ipipe_enable_pipeline() -- We are running on the boot CPU, hw
+ * interrupts are off, and secondary CPUs are still lost in space.
+ */
+void __ipipe_enable_pipeline(void)
+{
+	unsigned long flags;
+	unsigned irq;
+
+	flags = ipipe_critical_enter(NULL);
+
+	/* First, virtualize all interrupts from the root domain. */
+
+	for (irq = 0; irq < NR_IRQS; irq++)
+		ipipe_virtualize_irq(ipipe_root_domain,
+				     irq,
+				     &__ipipe_do_IRQ, NULL,
+				     &__ipipe_ack_irq,
+				     IPIPE_HANDLE_MASK | IPIPE_PASS_MASK);
+	/*
+	 * We use a virtual IRQ to handle the timer irq (decrementer trap)
+	 * which has been allocated early in __ipipe_init_platform().
+	 */
+
+	ipipe_virtualize_irq(ipipe_root_domain,
+			     IPIPE_TIMER_VIRQ,
+			     &__ipipe_do_timer, NULL,
+			     NULL, IPIPE_HANDLE_MASK | IPIPE_PASS_MASK);
+
+	ipipe_critical_exit(flags);
+}
+
+int ipipe_get_sysinfo(struct ipipe_sysinfo *info)
+{
+	info->ncpus = num_online_cpus();
+	info->cpufreq = ipipe_cpu_freq();
+	info->archdep.tmirq = IPIPE_TIMER_VIRQ;
+	info->archdep.tmfreq = info->cpufreq;
+
+	return 0;
+}
+
+/*
+ * ipipe_trigger_irq() -- Push the interrupt at front of the pipeline
+ * just like if it has been actually received from a hw source. Also
+ * works for virtual interrupts.
+ */
+int ipipe_trigger_irq(unsigned irq)
+{
+	unsigned long flags;
+
+#ifdef CONFIG_IPIPE_DEBUG
+	if (irq >= IPIPE_NR_IRQS ||
+	    (ipipe_virtual_irq_p(irq)
+	     && !test_bit(irq - IPIPE_VIRQ_BASE, &__ipipe_virtual_irq_map)))
+		return -EINVAL;
+#endif
+	local_irq_save_hw(flags);
+	__ipipe_handle_irq(irq, NULL);
+	local_irq_restore_hw(flags);
+
+	return 1;
+}
+
+/*
+ * __ipipe_handle_irq() -- IPIPE's generic IRQ handler. An optimistic
+ * interrupt protection log is maintained here for each domain. Hw
+ * interrupts are off on entry.
+ */
+void __ipipe_handle_irq(int irq, struct pt_regs *regs)
+{
+	struct ipipe_domain *this_domain, *next_domain;
+	struct list_head *head, *pos;
+	int m_ack;
+
+	/* Software-triggered IRQs do not need any ack. */
+	m_ack = (regs == NULL);
+
+#ifdef CONFIG_IPIPE_DEBUG
+	if (unlikely(irq >= IPIPE_NR_IRQS)) {
+		printk(KERN_ERR "I-pipe: spurious interrupt %d\n", irq);
+		return;
+	}
+#endif
+	this_domain = __ipipe_current_domain;
+
+	if (unlikely(test_bit(IPIPE_STICKY_FLAG, &this_domain->irqs[irq].control)))
+		head = &this_domain->p_link;
+	else {
+		head = __ipipe_pipeline.next;
+		next_domain = list_entry(head, struct ipipe_domain, p_link);
+		if (likely(test_bit(IPIPE_WIRED_FLAG, &next_domain->irqs[irq].control))) {
+			if (!m_ack && next_domain->irqs[irq].acknowledge)
+				next_domain->irqs[irq].acknowledge(irq, irq_desc + irq);
+			__ipipe_dispatch_wired(next_domain, irq);
+			return;
+		}
+	}
+
+	/* Ack the interrupt. */
+
+	pos = head;
+
+	while (pos != &__ipipe_pipeline) {
+		next_domain = list_entry(pos, struct ipipe_domain, p_link);
+		prefetch(next_domain);
+		/*
+		 * For each domain handling the incoming IRQ, mark it as
+		 * pending in its log.
+		 */
+		if (test_bit(IPIPE_HANDLE_FLAG, &next_domain->irqs[irq].control)) {
+			/*
+			 * Domains that handle this IRQ are polled for
+			 * acknowledging it by decreasing priority order. The
+			 * interrupt must be made pending _first_ in the
+			 * domain's status flags before the PIC is unlocked.
+			 */
+			__ipipe_set_irq_pending(next_domain, irq);
+
+			if (!m_ack && next_domain->irqs[irq].acknowledge) {
+				next_domain->irqs[irq].acknowledge(irq, irq_desc + irq);
+				m_ack = 1;
+			}
+		}
+
+		/*
+		 * If the domain does not want the IRQ to be passed down the
+		 * interrupt pipe, exit the loop now.
+		 */
+		if (!test_bit(IPIPE_PASS_FLAG, &next_domain->irqs[irq].control))
+			break;
+
+		pos = next_domain->p_link.next;
+	}
+
+	/*
+	 * If the interrupt preempted the head domain, then do not
+	 * even try to walk the pipeline, unless an interrupt is
+	 * pending for it.
+	 */
+	if (test_bit(IPIPE_AHEAD_FLAG, &this_domain->flags) &&
+	    ipipe_head_cpudom_var(irqpend_himask) == 0)
+		return;
+
+	/*
+	 * Now walk the pipeline, yielding control to the highest
+	 * priority domain that has pending interrupt(s) or
+	 * immediately to the current domain if the interrupt has been
+	 * marked as 'sticky'. This search does not go beyond the
+	 * current domain in the pipeline.
+	 */
+
+	__ipipe_walk_pipeline(head);
+}
+
+int __ipipe_grab_irq(struct pt_regs *regs)
+{
+	extern int ppc_spurious_interrupts;
+	int irq;
+
+	irq = ppc_md.get_irq(regs);
+	if (unlikely(irq < 0)) {
+		if (irq == -1)
+			ppc_spurious_interrupts++;
+		goto root_checks;
+	}
+
+	__ipipe_handle_irq(irq, regs);
+
+root_checks:
+
+	if (__ipipe_root_domain_p) {
+		if (!test_bit(IPIPE_STALL_FLAG, &ipipe_root_cpudom_var(status)))
+			return 1;
+	}
+
+	return 0;
+}
+
+static void __ipipe_do_IRQ(unsigned irq, void *cookie)
+{
+	struct pt_regs *regs = &__raw_get_cpu_var(__ipipe_tick_regs);
+
+        hardirq_enter(0);
+	ppc_irq_dispatch_handler(regs, irq);
+        hardirq_exit(0);
+
+	if (softirq_pending(0))
+		do_softirq();
+}
+
+static void __ipipe_do_timer(unsigned irq, void *cookie)
+{
+	timer_interrupt(&__raw_get_cpu_var(__ipipe_tick_regs));
+}
+
+int __ipipe_grab_timer(struct pt_regs *regs)
+{
+	struct ipipe_domain *ipd, *head;
+
+	ipd = __ipipe_current_domain;
+	head = __ipipe_pipeline_head();
+
+	set_dec(DECREMENTER_MAX);
+
+	__raw_get_cpu_var(__ipipe_tick_regs).msr = regs->msr; /* for timer_interrupt() */
+	__raw_get_cpu_var(__ipipe_tick_regs).nip = regs->nip;
+
+	if (ipd != &ipipe_root)
+		__raw_get_cpu_var(__ipipe_tick_regs).msr &= ~MSR_EE;
+
+	if (test_bit(IPIPE_WIRED_FLAG, &head->irqs[IPIPE_TIMER_VIRQ].control))
+		/*
+		 * Finding a wired IRQ means that we do have a
+		 * registered head domain as well. The decrementer
+		 * interrupt requires no acknowledge, so we may branch
+		 * to the wired IRQ dispatcher directly. Additionally,
+		 * we may bypass checks for locked interrupts or
+		 * stalled stage (the decrementer cannot be locked and
+		 * the head domain is obviously not stalled since we
+		 * got there).
+		 */
+		__ipipe_dispatch_wired_nocheck(head, IPIPE_TIMER_VIRQ);
+	else
+		__ipipe_handle_irq(IPIPE_TIMER_VIRQ, NULL);
+
+	if (ipd == &ipipe_root) {
+		if (!test_bit(IPIPE_STALL_FLAG, &ipipe_root_cpudom_var(status)))
+			return 1;
+	}
+
+	return 0;
+}
+
+notrace int __ipipe_check_root(void) /* hw IRQs off */
+{
+	return __ipipe_root_domain_p;
+}
+
+int __ipipe_syscall_root(struct pt_regs *regs)
+{
+	struct ipipe_percpu_domain_data *p;
+	unsigned long flags;
+        int ret;
+
+        /*
+         * This routine either returns:
+         * 0 -- if the syscall is to be passed to Linux;
+         * >0 -- if the syscall should not be passed to Linux, and no
+         * tail work should be performed;
+         * <0 -- if the syscall should not be passed to Linux but the
+         * tail work has to be performed (for handling signals etc).
+         */
+
+        if (!__ipipe_syscall_watched_p(current, regs->gpr[0]) ||
+            !__ipipe_event_monitored_p(IPIPE_EVENT_SYSCALL))
+                return 0;
+
+        ret = __ipipe_dispatch_event(IPIPE_EVENT_SYSCALL, regs);
+
+	local_irq_save_hw(flags);
+
+        if (!__ipipe_root_domain_p) {
+		local_irq_restore_hw(flags);
+		return 1;
+	}
+
+	p = ipipe_root_cpudom_ptr();
+	if ((p->irqpend_himask & IPIPE_IRQMASK_VIRT) != 0)
+		__ipipe_sync_pipeline(IPIPE_IRQMASK_VIRT);
+
+	local_irq_restore_hw(flags);
+
+	return -ret;
+}
+
+void __ipipe_pin_range_globally(unsigned long start, unsigned long end)
+{
+	/* We don't support this. */
+}
+
+EXPORT_SYMBOL_GPL(__switch_to);
+EXPORT_SYMBOL_GPL(show_stack);
+EXPORT_SYMBOL_GPL(_switch);
+EXPORT_SYMBOL_GPL(tasklist_lock);
+void atomic_set_mask(unsigned long mask, unsigned long *ptr);
+void atomic_clear_mask(unsigned long mask, unsigned long *ptr);
+#ifdef FEW_CONTEXTS
+EXPORT_SYMBOL_GPL(nr_free_contexts);
+EXPORT_SYMBOL_GPL(context_mm);
+EXPORT_SYMBOL_GPL(steal_context);
+#endif	/* !FEW_CONTEXTS */
+EXPORT_SYMBOL_GPL(atomic_set_mask);
+EXPORT_SYMBOL_GPL(atomic_clear_mask);
+EXPORT_SYMBOL_GPL(last_task_used_math);
diff --git a/arch/ppc/kernel/irq.c b/arch/ppc/kernel/irq.c
index 8c9f63d..2558665 100644
--- a/arch/ppc/kernel/irq.c
+++ b/arch/ppc/kernel/irq.c
@@ -433,7 +433,9 @@ void ppc_irq_dispatch_handler(struct pt_regs *regs, int irq)
 
 	kstat.irqs[cpu][irq]++;
 	spin_lock(&desc->lock);
+#ifndef CONFIG_IPIPE
 	ack_irq(irq);
+#endif /* CONFIG_IPIPE */
 	/*
 	   REPLAY is when Linux resends an IRQ that was dropped earlier
 	   WAITING is used by probe to mark irqs that are being tested
diff --git a/arch/ppc/kernel/mpc5xxx_pic.c b/arch/ppc/kernel/mpc5xxx_pic.c
index fd1f458..b303c88 100644
--- a/arch/ppc/kernel/mpc5xxx_pic.c
+++ b/arch/ppc/kernel/mpc5xxx_pic.c
@@ -26,7 +26,7 @@
 #include <asm/mpc5xxx.h>
 
 static void
-mpc5xxx_ic_disable(unsigned int irq)
+__mpc5xxx_ic_disable(unsigned int irq)
 {
 	struct mpc5xxx_intr *intr = (struct mpc5xxx_intr *)MPC5xxx_INTR;
 	struct mpc5xxx_sdma *sdma = (struct mpc5xxx_sdma *)MPC5xxx_SDMA;
@@ -63,7 +63,18 @@ mpc5xxx_ic_disable(unsigned int irq)
 }
 
 static void
-mpc5xxx_ic_enable(unsigned int irq)
+mpc5xxx_ic_disable(unsigned int irq)
+{
+	unsigned long flags;
+
+	local_irq_save_hw_cond(flags);
+	__mpc5xxx_ic_disable(irq);
+	ipipe_irq_lock(irq);
+	local_irq_restore_hw_cond(flags);
+}
+
+static void
+__mpc5xxx_ic_enable(unsigned int irq)
 {
 	struct mpc5xxx_intr *intr = (struct mpc5xxx_intr *)MPC5xxx_INTR;
 	struct mpc5xxx_sdma *sdma = (struct mpc5xxx_sdma *)MPC5xxx_SDMA;
@@ -100,6 +111,17 @@ mpc5xxx_ic_enable(unsigned int irq)
 }
 
 static void
+mpc5xxx_ic_enable(unsigned int irq)
+{
+	unsigned long flags;
+
+	local_irq_save_hw_cond(flags);
+	__mpc5xxx_ic_enable(irq);
+	ipipe_irq_unlock(irq);
+	local_irq_restore_hw_cond(flags);
+}
+
+static void
 mpc5xxx_ic_ack(unsigned int irq)
 {
 	struct mpc5xxx_intr *intr = (struct mpc5xxx_intr *)MPC5xxx_INTR;
@@ -149,15 +171,21 @@ mpc5xxx_ic_ack(unsigned int irq)
 static void
 mpc5xxx_ic_disable_and_ack(unsigned int irq)
 {
-	mpc5xxx_ic_disable(irq);
+	__mpc5xxx_ic_disable(irq);
 	mpc5xxx_ic_ack(irq);
 }
 
 static void
 mpc5xxx_ic_end(unsigned int irq)
 {
-	if (!(irq_desc[irq].status & (IRQ_DISABLED | IRQ_INPROGRESS)))
-		mpc5xxx_ic_enable(irq);
+	unsigned long flags;
+
+	if (!ipipe_root_domain_p ||
+	    !(irq_desc[irq].status & (IRQ_DISABLED | IRQ_INPROGRESS))) {
+		local_irq_save_hw_cond(flags);
+		__mpc5xxx_ic_enable(irq);
+		local_irq_restore_hw_cond(flags);
+	}
 }
 
 static struct hw_interrupt_type mpc5xxx_ic = {
diff --git a/arch/ppc/kernel/ppc4xx_pic.c b/arch/ppc/kernel/ppc4xx_pic.c
index 7fb2311..b110c13 100644
--- a/arch/ppc/kernel/ppc4xx_pic.c
+++ b/arch/ppc/kernel/ppc4xx_pic.c
@@ -103,13 +103,17 @@ ppc403_pic_get_irq(struct pt_regs *regs)
 static void
 ppc403_aic_enable(unsigned int irq)
 {
+	unsigned long flags;
 	int bit, word;
 
 	bit = irq & 0x1f;
 	word = irq >> 5;
 
+	local_irq_save_hw_cond(flags);
 	ppc_cached_irq_mask[word] |= (1 << (31 - bit));
 	mtdcr(DCRN_EXIER, ppc_cached_irq_mask[word]);
+	ipipe_irq_unlock(irq);
+	local_irq_restore_hw_cond(flags);
 }
 
 static void
@@ -120,8 +124,11 @@ ppc403_aic_disable(unsigned int irq)
 	bit = irq & 0x1f;
 	word = irq >> 5;
 
+	local_irq_save_hw_cond(flags);
 	ppc_cached_irq_mask[word] &= ~(1 << (31 - bit));
 	mtdcr(DCRN_EXIER, ppc_cached_irq_mask[word]);
+	ipipe_irq_lock(irq);
+	local_irq_restore_hw_cond(flags);
 }
 
 static void
@@ -148,6 +155,7 @@ ppc405_uic_enable(unsigned int irq)
 {
 	int bit, word;
 	irq_desc_t *desc = irq_desc + irq;
+	unsigned long flags;
 
 	bit = irq & 0x1f;
 	word = irq >> 5;
@@ -155,6 +163,7 @@ ppc405_uic_enable(unsigned int irq)
 #ifdef UIC_DEBUG
 	printk("ppc405_uic_enable - irq %d word %d bit 0x%x\n", irq, word, bit);
 #endif
+	local_irq_save_hw_cond(flags);
 	ppc_cached_irq_mask[word] |= 1 << (31 - bit);
 	switch (word) {
 	case 0:
@@ -182,12 +191,14 @@ ppc405_uic_enable(unsigned int irq)
 		desc->status = desc->status & ~IRQ_LEVEL;
 	break;
 	}
-
+	ipipe_irq_unlock(irq);
+	local_irq_restore_hw_cond(flags);
 }
 
 static void
 ppc405_uic_disable(unsigned int irq)
 {
+	unsigned long flags;
 	int bit, word;
 
 	bit = irq & 0x1f;
@@ -196,6 +207,7 @@ ppc405_uic_disable(unsigned int irq)
 	printk("ppc405_uic_disable - irq %d word %d bit 0x%x\n", irq, word,
 	       bit);
 #endif
+	local_irq_save_hw_cond(flags);
 	ppc_cached_irq_mask[word] &= ~(1 << (31 - bit));
 	switch (word) {
 	case 0:
@@ -205,6 +217,8 @@ ppc405_uic_disable(unsigned int irq)
 		mtdcr(DCRN_UIC_ER(UIC1), ppc_cached_irq_mask[word]);
 		break;
 	}
+	ipipe_irq_lock(irq);
+	local_irq_restore_hw_cond(flags);
 }
 
 static void
@@ -241,6 +255,7 @@ ppc405_uic_end(unsigned int irq)
 {
 	int bit, word;
 	unsigned int tr_bits;
+	unsigned long flags;
 
 	bit = irq & 0x1f;
 	word = irq >> 5;
@@ -249,6 +264,8 @@ ppc405_uic_end(unsigned int irq)
 	printk("ppc405_uic_end - irq %d word %d bit 0x%x\n", irq, word, bit);
 #endif
 
+	local_irq_save_hw_cond(flags);
+
 	switch (word) {
 	case 0:
 		tr_bits = mfdcr(DCRN_UIC_TR(UIC0));
@@ -274,7 +291,8 @@ ppc405_uic_end(unsigned int irq)
 		}
 	}
 
-	if (!(irq_desc[irq].status & (IRQ_DISABLED | IRQ_INPROGRESS))) {
+	if (!__ipipe_root_domain_p ||
+	    !(irq_desc[irq].status & (IRQ_DISABLED | IRQ_INPROGRESS))) {
 		ppc_cached_irq_mask[word] |= 1 << (31 - bit);
 		switch (word) {
 		case 0:
@@ -285,6 +303,8 @@ ppc405_uic_end(unsigned int irq)
 			break;
 		}
 	}
+
+	local_irq_restore_hw_cond(flags);
 }
 
 static struct hw_interrupt_type ppc405_uic = {
diff --git a/arch/ppc/kernel/ppc_ksyms.c b/arch/ppc/kernel/ppc_ksyms.c
index d90d323..513c65d 100644
--- a/arch/ppc/kernel/ppc_ksyms.c
+++ b/arch/ppc/kernel/ppc_ksyms.c
@@ -314,6 +314,7 @@ EXPORT_SYMBOL(screen_info);
 #endif
 
 EXPORT_SYMBOL(__delay);
+#ifndef CONFIG_IPIPE
 EXPORT_SYMBOL(__sti);
 EXPORT_SYMBOL(__sti_end);
 EXPORT_SYMBOL(__cli);
@@ -322,6 +323,7 @@ EXPORT_SYMBOL(__save_flags_ptr);
 EXPORT_SYMBOL(__save_flags_ptr_end);
 EXPORT_SYMBOL(__restore_flags);
 EXPORT_SYMBOL(__restore_flags_end);
+#endif /* CONFIG_IPIPE */
 EXPORT_SYMBOL(timer_interrupt_intercept);
 EXPORT_SYMBOL(timer_interrupt);
 EXPORT_SYMBOL(do_IRQ_intercept);
diff --git a/arch/ppc/kernel/traps.c b/arch/ppc/kernel/traps.c
index aa4eaff..6f37807 100644
--- a/arch/ppc/kernel/traps.c
+++ b/arch/ppc/kernel/traps.c
@@ -211,6 +211,9 @@ MachineCheckException(struct pt_regs *regs)
 {
 	unsigned long reason = get_reason(regs);
 
+	if (ipipe_trap_notify(IPIPE_TRAP_MCE, regs))
+	    	return;
+
 	if (user_mode(regs)) {
 		_exception(SIGBUS, regs, BUS_ADRERR, regs->nip);
 		return;
@@ -314,6 +317,8 @@ SMIException(struct pt_regs *regs)
 void
 UnknownException(struct pt_regs *regs)
 {
+	if (ipipe_trap_notify(IPIPE_TRAP_UNKNOWN, regs))
+	    	return;
 	printk("Bad trap at PC: %lx, SR: %lx, vector=%lx    %s\n",
 	       regs->nip, regs->msr, regs->trap, print_tainted());
 	_exception(SIGTRAP, regs, 0, 0);
@@ -322,6 +327,8 @@ UnknownException(struct pt_regs *regs)
 void
 InstructionBreakpoint(struct pt_regs *regs)
 {
+	if (ipipe_trap_notify(IPIPE_TRAP_IABR, regs))
+	    	return;
 	if (debugger_iabr_match(regs))
 		return;
 	_exception(SIGTRAP, regs, TRAP_BRKPT, 0);
@@ -330,6 +337,8 @@ InstructionBreakpoint(struct pt_regs *regs)
 void
 RunModeException(struct pt_regs *regs)
 {
+	if (ipipe_trap_notify(IPIPE_TRAP_RM, regs))
+	    	return;
 	_exception(SIGTRAP, regs, 0, 0);
 }
 
@@ -382,6 +391,8 @@ static void emulate_single_step(struct pt_regs *regs)
 {
 	if (single_stepping(regs)) {
 		clear_single_step(regs);
+		if (ipipe_trap_notify(IPIPE_TRAP_SSTEP, regs))
+		    	return;
 		if (debugger_sstep(regs))
 			return;
 		_exception(SIGTRAP, regs, TRAP_TRACE, 0);
@@ -394,6 +405,9 @@ ProgramCheckException(struct pt_regs *regs)
 	unsigned int reason = get_reason(regs);
 	extern int do_mathemu(struct pt_regs *regs);
 
+	if (ipipe_trap_notify(IPIPE_TRAP_PCE, regs))
+	    	return;
+
 #ifdef CONFIG_MATH_EMULATION
 	/* (reason & REASON_ILLEGAL) would be the obvious thing here,
 	 * but there seems to be a hardware bug on the 405GP (RevD)
@@ -457,6 +471,8 @@ void
 SingleStepException(struct pt_regs *regs)
 {
 	regs->msr &= ~MSR_SE;  /* Turn off 'trace' bit */
+	if (ipipe_trap_notify(IPIPE_TRAP_SSTEP, regs))
+	    	return;
 	if (debugger_sstep(regs))
 		return;
 	_exception(SIGTRAP, regs, TRAP_TRACE, 0);
@@ -473,6 +489,8 @@ AlignmentException(struct pt_regs *regs)
 		emulate_single_step(regs);
 		return;
 	}
+	if (ipipe_trap_notify(IPIPE_TRAP_ALIGNMENT, regs))
+	    	return;
 	if (fixed == -EFAULT) {
 		/* fixed == -EFAULT means the operand address was bad */
 		if (user_mode(regs))
@@ -510,6 +528,9 @@ SoftwareEmulation(struct pt_regs *regs)
 	extern int Soft_emulate_8xx(struct pt_regs *);
 	int errcode;
 
+	if (ipipe_trap_notify(IPIPE_TRAP_SOFTEMU, regs))
+	    	return;
+
 	if (!user_mode(regs)) {
 		debugger(regs);
 		die("Kernel Mode Software FPU Emulation", regs, SIGFPE);
@@ -538,6 +559,9 @@ void DebugException(struct pt_regs *regs)
 {
 	unsigned long debug_status;
 
+	if (ipipe_trap_notify(IPIPE_TRAP_DEBUG, regs))
+	    	return;
+
 	debug_status = mfspr(SPRN_DBSR);
 
 	regs->msr &= ~MSR_DE;  /* Turn off 'debug' bit */
@@ -574,6 +598,8 @@ TAUException(struct pt_regs *regs)
 void
 AltivecAssistException(struct pt_regs *regs)
 {
+	if (ipipe_trap_notify(IPIPE_TRAP_ALTASSIST, regs))
+	    	return;
 	if (regs->msr & MSR_VEC)
 		giveup_altivec(current);
 	/* XXX quick hack for now: set the non-Java bit in the VSCR */
@@ -603,6 +629,9 @@ SPEFloatingPointException(struct pt_regs *regs)
 	int fpexc_mode;
 	int code = 0;
 
+	if (ipipe_trap_notify(IPIPE_TRAP_SPE, regs))
+	    	return;
+
 	spefscr = current->thread.spefscr;
 	fpexc_mode = current->thread.fpexc_mode;
 
diff --git a/arch/ppc/mm/fault.c b/arch/ppc/mm/fault.c
index 19fe78e..a3b36f8 100644
--- a/arch/ppc/mm/fault.c
+++ b/arch/ppc/mm/fault.c
@@ -99,7 +99,7 @@ void do_page_fault(struct pt_regs *regs, unsigned long address,
 		   unsigned long error_code)
 {
 	struct vm_area_struct * vma;
-	struct mm_struct *mm = current->mm;
+	struct mm_struct *mm;
 	siginfo_t info;
 	int code = SEGV_MAPERR;
 #if defined(CONFIG_4xx) || defined (CONFIG_BOOKE)
@@ -119,6 +119,11 @@ void do_page_fault(struct pt_regs *regs, unsigned long address,
 		is_write = error_code & 0x02000000;
 #endif /* CONFIG_4xx || CONFIG_BOOKE */
 
+	if (ipipe_trap_notify(IPIPE_TRAP_ACCESS, regs))
+	    	return;
+
+	mm = current->mm;
+
 #if defined(CONFIG_XMON) || defined(CONFIG_KGDB)
 	if (debugger_fault_handler && regs->trap == 0x300) {
 		debugger_fault_handler(regs);
diff --git a/arch/ppc/platforms/icecube.c b/arch/ppc/platforms/icecube.c
index 40b6040..c35c2fa 100644
--- a/arch/ppc/platforms/icecube.c
+++ b/arch/ppc/platforms/icecube.c
@@ -46,6 +46,9 @@
 unsigned char __res[sizeof(bd_t)];
 #endif
 
+void
+mpc5xxx_progress(char *s, unsigned short hex);
+
 extern int mpc5xxx_setkeycode(unsigned int scancode, unsigned int keycode);
 extern int mpc5xxx_getkeycode(unsigned int scancode);
 extern int mpc5xxx_translate(unsigned char scancode, unsigned char *keycode,
